<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SelectSepet StructType
 * @subpackage Structs
 */
class SelectSepet extends AbstractStructBase
{
    /**
     * The UyeKodu
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UyeKodu;
    /**
     * The sepetId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $sepetId;
    /**
     * The uyeId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $uyeId;
    /**
     * The BaslangicTarihi
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $BaslangicTarihi;
    /**
     * The BitisTarihi
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $BitisTarihi;
    /**
     * Constructor method for SelectSepet
     * @uses SelectSepet::setUyeKodu()
     * @uses SelectSepet::setSepetId()
     * @uses SelectSepet::setUyeId()
     * @uses SelectSepet::setBaslangicTarihi()
     * @uses SelectSepet::setBitisTarihi()
     * @param string $uyeKodu
     * @param int $sepetId
     * @param int $uyeId
     * @param string $baslangicTarihi
     * @param string $bitisTarihi
     */
    public function __construct($uyeKodu = null, $sepetId = null, $uyeId = null, $baslangicTarihi = null, $bitisTarihi = null)
    {
        $this
            ->setUyeKodu($uyeKodu)
            ->setSepetId($sepetId)
            ->setUyeId($uyeId)
            ->setBaslangicTarihi($baslangicTarihi)
            ->setBitisTarihi($bitisTarihi);
    }
    /**
     * Get UyeKodu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUyeKodu()
    {
        return isset($this->UyeKodu) ? $this->UyeKodu : null;
    }
    /**
     * Set UyeKodu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $uyeKodu
     * @return \StructType\SelectSepet
     */
    public function setUyeKodu($uyeKodu = null)
    {
        // validation for constraint: string
        if (!is_null($uyeKodu) && !is_string($uyeKodu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uyeKodu, true), gettype($uyeKodu)), __LINE__);
        }
        if (is_null($uyeKodu) || (is_array($uyeKodu) && empty($uyeKodu))) {
            unset($this->UyeKodu);
        } else {
            $this->UyeKodu = $uyeKodu;
        }
        return $this;
    }
    /**
     * Get sepetId value
     * @return int|null
     */
    public function getSepetId()
    {
        return $this->sepetId;
    }
    /**
     * Set sepetId value
     * @param int $sepetId
     * @return \StructType\SelectSepet
     */
    public function setSepetId($sepetId = null)
    {
        // validation for constraint: int
        if (!is_null($sepetId) && !(is_int($sepetId) || ctype_digit($sepetId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sepetId, true), gettype($sepetId)), __LINE__);
        }
        $this->sepetId = $sepetId;
        return $this;
    }
    /**
     * Get uyeId value
     * @return int|null
     */
    public function getUyeId()
    {
        return $this->uyeId;
    }
    /**
     * Set uyeId value
     * @param int $uyeId
     * @return \StructType\SelectSepet
     */
    public function setUyeId($uyeId = null)
    {
        // validation for constraint: int
        if (!is_null($uyeId) && !(is_int($uyeId) || ctype_digit($uyeId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($uyeId, true), gettype($uyeId)), __LINE__);
        }
        $this->uyeId = $uyeId;
        return $this;
    }
    /**
     * Get BaslangicTarihi value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBaslangicTarihi()
    {
        return isset($this->BaslangicTarihi) ? $this->BaslangicTarihi : null;
    }
    /**
     * Set BaslangicTarihi value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $baslangicTarihi
     * @return \StructType\SelectSepet
     */
    public function setBaslangicTarihi($baslangicTarihi = null)
    {
        // validation for constraint: string
        if (!is_null($baslangicTarihi) && !is_string($baslangicTarihi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($baslangicTarihi, true), gettype($baslangicTarihi)), __LINE__);
        }
        if (is_null($baslangicTarihi) || (is_array($baslangicTarihi) && empty($baslangicTarihi))) {
            unset($this->BaslangicTarihi);
        } else {
            $this->BaslangicTarihi = $baslangicTarihi;
        }
        return $this;
    }
    /**
     * Get BitisTarihi value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBitisTarihi()
    {
        return isset($this->BitisTarihi) ? $this->BitisTarihi : null;
    }
    /**
     * Set BitisTarihi value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $bitisTarihi
     * @return \StructType\SelectSepet
     */
    public function setBitisTarihi($bitisTarihi = null)
    {
        // validation for constraint: string
        if (!is_null($bitisTarihi) && !is_string($bitisTarihi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bitisTarihi, true), gettype($bitisTarihi)), __LINE__);
        }
        if (is_null($bitisTarihi) || (is_array($bitisTarihi) && empty($bitisTarihi))) {
            unset($this->BitisTarihi);
        } else {
            $this->BitisTarihi = $bitisTarihi;
        }
        return $this;
    }
}
